'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lib = require('./../lib');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ErrorController = function (_Controller) {
  _inherits(ErrorController, _Controller);

  function ErrorController(props) {
    _classCallCheck(this, ErrorController);

    return _possibleConstructorReturn(this, (ErrorController.__proto__ || Object.getPrototypeOf(ErrorController)).call(this, props));
  }

  _createClass(ErrorController, [{
    key: 'noRouteAction',
    value: function noRouteAction(parameters) {
      this.sendView('Errors/noRoute');
    }
  }, {
    key: 'actionErrorAction',
    value: function actionErrorAction(parameters) {

      var error = parameters.get('error');
      var message = error.message;
      var stack = error.stack;

      var actionName = parameters.get('actionName');
      var controllerName = parameters.get('controllerName');

      this.sendView('Errors/actionError', {
        message: message,
        stack: stack,
        controllerName: controllerName,
        actionName: actionName
      });
    }
  }]);

  return ErrorController;
}(_lib.Controller);

exports.default = ErrorController;