'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ControllerResponseType = require('./../ControllerResponseType');

var _ControllerResponseType2 = _interopRequireDefault(_ControllerResponseType);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _Renderer = require('./../Renderer');

var _reactRedux = require('react-redux');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RenderComponent = function (_ControllerResponseTy) {
  _inherits(RenderComponent, _ControllerResponseTy);

  function RenderComponent(props) {
    _classCallCheck(this, RenderComponent);

    var _this = _possibleConstructorReturn(this, (RenderComponent.__proto__ || Object.getPrototypeOf(RenderComponent)).call(this));

    _this.req = props.req;
    _this.preloadedState = props.preloadedState || {};
    _this.targetView = props.targetView;
    _this.projectPath = props.projectPath;
    return _this;
  }

  _createClass(RenderComponent, [{
    key: 'render',
    value: function render(props) {
      var _this2 = this;

      var req = this.req;
      var preloadedState = this.preloadedState;

      return new Promise(function (fulfill, reject) {
        if (_this2.content != null) {
          fulfill(_this2.content);
        } else {
          //let compPath = `${this.projectPath}/Client/server-client.js`;
          //let compPath = `${this.projectPath}/Client/browser-client.js`;

          var compPath = _this2.projectPath + '/Client/index.js';

          //        let compPath = '/Users/matt/Development/publicgit/yahoiApp/dist/public/js/main.js'

          //        console.log('thisss', compPath);

          // turn off for prod env
          if (typeof require.cache[compPath] != 'undefined') {
            delete require.cache[compPath];
          }
          var _preloadedState = { Auth: { a: 1 } };
          var injectedPreloadedState = JSON.stringify(_preloadedState);

          var sourceComponent = require(compPath).default;
          var Component = _react2.default.createFactory(sourceComponent);
          var ssr = {
            location: req.url,
            context: {},
            preloadedState: _preloadedState
          };
          var renderedClient = (0, _server.renderToString)(_react2.default.createElement(Component, { ssr: ssr }));
          var CLIENT_INJECTOR = '<script>window.__PRELOADED_STATE__=' + injectedPreloadedState + '</script><div id=\'client-wrapper\'>' + renderedClient + '</div><script src="/public/js/vendor.js"></script><script src="/public/js/main.js"></script>';
          var viewRenderer = new _Renderer.ViewRenderer();
          viewRenderer.render(_this2.projectPath + '/Views/' + _this2.targetView, { CLIENT: CLIENT_INJECTOR }).then(function (renderedHtml) {
            fulfill(renderedHtml);
          }).catch(function (e) {
            console.log(e);
            reject(e);
          });
        }
      });
    }
  }, {
    key: 'respond',
    value: function respond(req, res) {
      this.render(req).then(function (content) {
        res.send(content);
      }).catch(function (e) {
        console.log(e);
        res.send('error: ' + String(e));
      });
    }
  }]);

  return RenderComponent;
}(_ControllerResponseType2.default);

exports.default = RenderComponent;